# Contributing

Contributions are welcome from the community. Questions can be asked on the
[issues page][1]. Before creating a new issue, please take a moment to search
and make sure a similar issue does not already exist. If one does exist, you
can comment (most simply even with just a :+1:) to show your support for that
issue.

If you have direct contributions you would like considered for incorporation
into the project you can [fork this repository][2] and
[submit a merge request][3] for review.

## Style Guide

This project loosely adheres to [Google Java Style][4] and is informed by
[Effective Java][5]. All source files and documentation are encoded using
[UTF-8][6]. Developers should also consider the following:

* Line lengths:
  * code: __100__, but shorter is better.
  * comments: __80__, for readability.
* Use unicode symbols where possible: `double μ = 0.4;`
* Use static imports for only the most common utilities and preconditions:
  * `java.lang.math`
  * `com.google.common.base.Preconditions`

[1]: https://code.usgs.gov/ghsc/nshmp/nshmp-lib/-/issues
[2]: https://docs.gitlab.com/ee/user/project/repository/forking_workflow.html#creating-a-fork
[3]: https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html
[4]: https://google.github.io/styleguide/javaguide.html
[5]: http://en.wikipedia.org/wiki/Joshua_Bloch#Effective_Java
[6]: https://en.wikipedia.org/?title=UTF-8
