package gov.usgs.earthquake.nshmp;

import gov.usgs.earthquake.nshmp.geo.Location;

/**
 * Marker interface for {@link Location}s with place names that are used when
 * comparing hazard models. This interface is typically implemented by
 * {@code enum} types where {@link #name()} returns the {@link Enum#name()}.
 * Implementors should override {@link Object#toString()} to return a
 * presentation-friendly label.
 *
 * @author U.S. Geological Survey
 */
public interface NamedLocation {

  /**
   * The location.
   */
  Location location();

  /**
   * The place name of the location.
   */
  String name();

}
