package gov.usgs.earthquake.nshmp.gmm;

import static gov.usgs.earthquake.nshmp.gmm.Gmm.AB_03_GLOBAL_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AB_06_PRIME;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_ALASKA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_CASCADIA_INTERFACE_ADJUSTED_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_CASCADIA_SLAB_ADJUSTED_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_CASCADIA_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_GLOBAL_INTERFACE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AG_20_GLOBAL_INTERFACE_AK_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AM_09_INTERFACE_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AM_09_INTERFACE_BASIN_M9;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ASK_14;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ASK_14_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ASK_14_CYBERSHAKE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.AS_97_AK;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ATKINSON_08_PRIME;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ATKINSON_10;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.BCHYDRO_12_INTERFACE_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.BCHYDRO_12_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.BCHYDRO_12_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.BJF_97_AK;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.BSSA_14;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.BSSA_14_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.BSSA_14_CYBERSHAKE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CAMPBELL_03;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CB_03_AK_FAULT;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CB_14;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CB_14_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CB_14_CYBERSHAKE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CY_14;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CY_14_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.CY_14_CYBERSHAKE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.FRANKEL_96;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.GEOMATRIX_93_INTERFACE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.GEOMATRIX_93_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.IDRISS_14;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_ALASKA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_CASCADIA_INTERFACE_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_CASCADIA_INTERFACE_SEATTLE_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_CASCADIA_INTERFACE_SEATTLE_BASIN_M9;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_CASCADIA_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_CASCADIA_SLAB_SEATTLE_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_GLOBAL_INTERFACE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.KBCG_20_GLOBAL_INTERFACE_AK_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_2018;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_2023;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_2023_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_2023_CPA;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_SEEDS_2018;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_SEEDS_2023;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_SEEDS_2023_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.NGA_EAST_SEEDS_2023_CPA;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PEZESHK_11;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSBAH_20_ALASKA_SLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSBAH_20_CASCADIA_INTERFACE_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSBAH_20_CASCADIA_INTERFACE_BASIN_M9;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSBAH_20_CASCADIA_SLAB_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSBAH_20_GLOBAL_INTERFACE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.PSBAH_20_GLOBAL_INTERFACE_AK_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.SADIGH_97;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.SADIGH_97_AK_INTERFACE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.SILVA_02;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.SOMERVILLE_01;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.TORO_97_MW;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.TP_05;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.USGS_PRVI_ACTIVE_CRUST;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.USGS_PRVI_ACTIVE_CRUST_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.USGS_PRVI_INTERFACE;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.USGS_PRVI_INTERFACE_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.USGS_PRVI_INTRASLAB;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.USGS_PRVI_INTRASLAB_ADJUSTED;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.WONG_15;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ZHAO_06_INTERFACE_BASIN;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ZHAO_06_INTERFACE_BASIN_M9;
import static gov.usgs.earthquake.nshmp.gmm.Gmm.ZHAO_06_SLAB_BASIN;

import java.util.Map;
import java.util.Optional;

import gov.usgs.earthquake.nshmp.data.DoubleData;
import gov.usgs.earthquake.nshmp.gmm.GmmInput.Constraints;
import gov.usgs.earthquake.nshmp.tree.LogicTree;
import gov.usgs.earthquake.nshmp.tree.Trees;

/**
 * Convenience class for combined GMM implementations that compute weight
 * averaged ground motions and sigmas for a logic tree of ground motion models.
 * These are NOT intended for use in hazard calculations, but are made available
 * to support comparative deterministic analysis of GMM logic trees.
 */
class CombinedGmm implements GroundMotionModel {

  private static final String NAME = "Combined: ";
  private final LogicTree<GroundMotionModel> gmmTree;
  private final Imt imt;

  private CombinedGmm(Imt imt, Map<Gmm, Double> gmms) {
    this.gmmTree = GmmUtils.weightMapToInstanceTree(gmms, imt);
    this.imt = imt;

    double[] weights = gmms.values().stream()
        .mapToDouble(Double::doubleValue)
        .toArray();
    DoubleData.checkWeightSum(weights);
  }

  @Override
  public Imt imt() {
    return imt;
  }

  @Override
  public LogicTree<GroundMotion> calc(GmmInput in) {
    return Trees.transform(
        gmmTree,
        gmm -> GroundMotions.combine(gmm.calc(in)),
        Optional.of(GroundMotions.TREE_NAME));
  }

  /*
   * Implementations. For each, coefficients are only used to get the set of
   * supported IMTs and therefore reference a model that supports the
   * intersection of all support IMTs.
   */

  private static final Map<Gmm, Double> HI_DEEP_2021 = Map.of(
      ATKINSON_10, 0.4,
      BCHYDRO_12_SLAB, 0.4,
      WONG_15, 0.2);

  /* 2.0 deep earthquakes */
  static final class HawaiiDeep2021 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Hawaii Deep 2021 (2.0)";
    static final Constraints CONSTRAINTS = Atkinson_2010.CONSTRAINTS;
    static final CoefficientContainer COEFFS = Atkinson_2010.COEFFS;

    HawaiiDeep2021(Imt imt) {
      super(imt, HI_DEEP_2021);
    }
  }

  private static final Map<Gmm, Double> HI_SHALLOW_2021 = Map.of(
      ATKINSON_10, 0.2,
      ASK_14, 0.2,
      BSSA_14, 0.2,
      CB_14, 0.2,
      CY_14, 0.2);

  /* 2.0 shallow earthquakes */
  static final class HawaiiShallow2021 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Hawaii Shallow 2021 (2.0)";
    static final Constraints CONSTRAINTS = Atkinson_2010.CONSTRAINTS;
    static final CoefficientContainer COEFFS = Atkinson_2010.COEFFS;

    HawaiiShallow2021(Imt imt) {
      super(imt, HI_SHALLOW_2021);
    }
  }

  static final Map<Gmm, Double> STABLE_CRUST_2014 = Map.of(
      AB_06_PRIME, 0.22,
      ATKINSON_08_PRIME, 0.08,
      CAMPBELL_03, 0.11,
      FRANKEL_96, 0.06,
      PEZESHK_11, 0.15,
      SILVA_02, 0.06,
      SOMERVILLE_01, 0.1,
      TP_05, 0.11,
      TORO_97_MW, 0.11);

  /* Need to allow Vs30=3000 through for comparison plots. */
  private static final Constraints STABLE_2014_CONSTRAINTS = Constraints.builder()
      .withDefaults()
      .build();

  /* 4.0 Fault variant that includes Somerville. */
  static final class StableCrust2014 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Stable crust 2014 (4.*)";
    static final Constraints CONSTRAINTS = STABLE_2014_CONSTRAINTS;
    static final CoefficientContainer COEFFS = FrankelEtAl_1996.COEFFS;

    StableCrust2014(Imt imt) {
      super(imt, STABLE_CRUST_2014);
    }

    @Override
    public LogicTree<GroundMotion> calc(GmmInput in) {
      GmmInput.Builder b = GmmInput.builder().fromCopy(in);
      b.vs30(in.vs30 <= 760.0 ? 760.0 : 2000.0);
      return super.calc(b.build());
    }
  }

  private static final Map<Gmm, Double> STABLE_CRUST_2018 = Map.of(
      NGA_EAST_2018, 0.667,
      NGA_EAST_SEEDS_2018, 0.333);

  /* 5.0 */
  static final class StableCrust2018 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Stable crust 2018 (5.0)";
    static final Constraints CONSTRAINTS = NgaEast.CONSTRAINTS;
    static final CoefficientContainer COEFFS = NgaEast.COEFFS_SIGMA_PANEL;

    StableCrust2018(Imt imt) {
      super(imt, STABLE_CRUST_2018);
    }
  }

  private static final Map<Gmm, Double> STABLE_CRUST_2023 = Map.of(
      NGA_EAST_2023, 0.3333,
      NGA_EAST_2023_ADJUSTED, 0.3333,
      NGA_EAST_SEEDS_2023, 0.1667,
      NGA_EAST_SEEDS_2023_ADJUSTED, 0.1667);

  /* 6.0 50% NGA-East adjustment */
  static final class StableCrust2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Stable crust 2023 (6.0)";
    static final Constraints CONSTRAINTS = NgaEast.CONSTRAINTS;
    static final CoefficientContainer COEFFS = NgaEast.COEFFS_SIGMA_PANEL;

    StableCrust2023(Imt imt) {
      super(imt, STABLE_CRUST_2023);
    }
  }

  private static final Map<Gmm, Double> STABLE_CRUST_2023_CPA = Map.of(
      NGA_EAST_2023, 0.1667,
      NGA_EAST_2023_CPA, 0.1667,
      NGA_EAST_2023_ADJUSTED, 0.3333,
      NGA_EAST_SEEDS_2023, 0.0833,
      NGA_EAST_SEEDS_2023_CPA, 0.0833,
      NGA_EAST_SEEDS_2023_ADJUSTED, 0.1667);

  /* 6.0 50% NGA-East adjustments + 25% CPA */
  static final class StableCrustCpa2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Stable crust 2023 (6.0, CPA)";
    static final Constraints CONSTRAINTS = NgaEast.CONSTRAINTS;
    static final CoefficientContainer COEFFS = NgaEast.COEFFS_SIGMA_PANEL;

    StableCrustCpa2023(Imt imt) {
      super(imt, STABLE_CRUST_2023_CPA);
    }
  }

  private static final Map<Gmm, Double> ACTIVE_CRUST_2014_4P1 = Map.of(
      ASK_14, 0.22,
      BSSA_14, 0.22,
      CB_14, 0.22,
      CY_14, 0.22,
      IDRISS_14, 0.12);

  /* 4.1 */
  static final class ActiveCrust2014_4p1 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Active Crust 2014 (4.1)";
    static final Constraints CONSTRAINTS = CampbellBozorgnia_2014.CONSTRAINTS;
    static final CoefficientContainer COEFFS = Idriss_2014.COEFFS;

    ActiveCrust2014_4p1(Imt imt) {
      super(imt, ACTIVE_CRUST_2014_4P1);
    }
  }

  private static final Map<Gmm, Double> ACTIVE_CRUST_2014_4P2 = Map.of(
      ASK_14, 0.25,
      BSSA_14, 0.25,
      CB_14, 0.25,
      CY_14, 0.25);

  /* 4.2 */
  static final class ActiveCrust2014_4p2 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Active Crust 2014 (4.2, no Idriss)";
    static final Constraints CONSTRAINTS = CampbellBozorgnia_2014.CONSTRAINTS;
    static final CoefficientContainer COEFFS = CampbellBozorgnia_2014.COEFFS;

    ActiveCrust2014_4p2(Imt imt) {
      super(imt, ACTIVE_CRUST_2014_4P2);
    }
  }

  private static final Map<Gmm, Double> ACTIVE_CRUST_2018 = Map.of(
      ASK_14_BASIN, 0.25,
      BSSA_14_BASIN, 0.25,
      CB_14_BASIN, 0.25,
      CY_14_BASIN, 0.25);

  /* 5.0 No Idriss. */
  static final class ActiveCrust2018 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Active Crust 2018 (5.0, deep basins)";
    static final Constraints CONSTRAINTS = CampbellBozorgnia_2014.CONSTRAINTS;
    static final CoefficientContainer COEFFS = CampbellBozorgnia_2014.COEFFS;

    ActiveCrust2018(Imt imt) {
      super(imt, ACTIVE_CRUST_2018);
    }
  }

  /* 6.0 */
  static final class ActiveCrust2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Active Crust 2023 (6.0, deep basins)";
    static final Constraints CONSTRAINTS = CampbellBozorgnia_2014.CONSTRAINTS;
    static final CoefficientContainer COEFFS = CampbellBozorgnia_2014.COEFFS;

    ActiveCrust2023(Imt imt) {
      super(imt, ACTIVE_CRUST_2018);
    }
  }

  private static final Map<Gmm, Double> ACTIVE_CRUST_2023_SAN_FRANCISCO = Map.ofEntries(
      Map.entry(ASK_14, 0.125),
      Map.entry(BSSA_14, 0.125),
      Map.entry(CB_14, 0.125),
      Map.entry(CY_14, 0.125),
      Map.entry(ASK_14_BASIN, 0.125),
      Map.entry(BSSA_14_BASIN, 0.125),
      Map.entry(CB_14_BASIN, 0.125),
      Map.entry(CY_14_BASIN, 0.125));

  /* 6.0 SF Bay Area, 50% native basin */
  static final class ActiveCrustSanFrancisco2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Active Crust 2023 (6.0, San Francisco)";
    static final Constraints CONSTRAINTS = CampbellBozorgnia_2014.CONSTRAINTS;
    static final CoefficientContainer COEFFS = CampbellBozorgnia_2014.COEFFS;

    ActiveCrustSanFrancisco2023(Imt imt) {
      super(imt, ACTIVE_CRUST_2023_SAN_FRANCISCO);
    }
  }

  private static final Map<Gmm, Double> ACTIVE_CRUST_2023_LOS_ANGELES = Map.ofEntries(
      Map.entry(ASK_14, 0.125),
      Map.entry(BSSA_14, 0.125),
      Map.entry(CB_14, 0.125),
      Map.entry(CY_14, 0.125),
      Map.entry(ASK_14_BASIN, 0.0625),
      Map.entry(BSSA_14_BASIN, 0.0625),
      Map.entry(CB_14_BASIN, 0.0625),
      Map.entry(CY_14_BASIN, 0.0625),
      Map.entry(ASK_14_CYBERSHAKE, 0.0625),
      Map.entry(BSSA_14_CYBERSHAKE, 0.0625),
      Map.entry(CB_14_CYBERSHAKE, 0.0625),
      Map.entry(CY_14_CYBERSHAKE, 0.0625));

  /* 6.0 LA Basin, 50% native basin, 25% cybershake adjustment */
  static final class ActiveCrustLosAngeles2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Active Crust 2023 (6.0, Los Angeles)";
    static final Constraints CONSTRAINTS = CampbellBozorgnia_2014.CONSTRAINTS;
    static final CoefficientContainer COEFFS = CampbellBozorgnia_2014.COEFFS;

    ActiveCrustLosAngeles2023(Imt imt) {
      super(imt, ACTIVE_CRUST_2023_LOS_ANGELES);
    }
  }

  private static final Map<Gmm, Double> INTERFACE_2018 = Map.of(
      AM_09_INTERFACE_BASIN, 0.3333,
      BCHYDRO_12_INTERFACE_BASIN, 0.3334,
      ZHAO_06_INTERFACE_BASIN, 0.3333);

  /* 5.0 */
  static final class Interface2018 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Interface 2018 (5.0, deep basins)";
    static final Constraints CONSTRAINTS = AtkinsonMacias_2009.CONSTRAINTS;
    static final CoefficientContainer COEFFS = AtkinsonMacias_2009.COEFFS;

    Interface2018(Imt imt) {
      super(imt, INTERFACE_2018);
    }
  }

  private static final Map<Gmm, Double> INTRASLAB_2018 = Map.of(
      BCHYDRO_12_SLAB_BASIN, 0.5,
      ZHAO_06_SLAB_BASIN, 0.5);

  /* 5.0 */
  static final class Intraslab2018 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Intraslab 2018 (5.0, deep basins)";
    static final Constraints CONSTRAINTS = BcHydro_2012.CONSTRAINTS;
    static final CoefficientContainer COEFFS = BcHydro_2012.COEFFS;

    Intraslab2018(Imt imt) {
      super(imt, INTRASLAB_2018);
    }
  }

  private static final Map<Gmm, Double> INTERFACE_2023 = Map.of(
      AM_09_INTERFACE_BASIN, 0.125,
      ZHAO_06_INTERFACE_BASIN, 0.125,
      AG_20_CASCADIA_INTERFACE_ADJUSTED_BASIN, 0.25,
      KBCG_20_CASCADIA_INTERFACE_BASIN, 0.25,
      PSBAH_20_CASCADIA_INTERFACE_BASIN, 0.25);

  /* 6.0 */
  static final class Interface2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Interface 2023 (6.0, deep basins)";
    static final Constraints CONSTRAINTS = AtkinsonMacias_2009.CONSTRAINTS;
    static final CoefficientContainer COEFFS = AtkinsonMacias_2009.COEFFS;

    Interface2023(Imt imt) {
      super(imt, INTERFACE_2023);
    }
  }

  private static final Map<Gmm, Double> INTERFACE_2023_SEATTLE = Map.of(
      AM_09_INTERFACE_BASIN, 0.0625,
      AM_09_INTERFACE_BASIN_M9, 0.0625,
      ZHAO_06_INTERFACE_BASIN, 0.0625,
      ZHAO_06_INTERFACE_BASIN_M9, 0.0625,
      AG_20_CASCADIA_INTERFACE_ADJUSTED_BASIN, 0.25,
      KBCG_20_CASCADIA_INTERFACE_SEATTLE_BASIN, 0.125,
      KBCG_20_CASCADIA_INTERFACE_SEATTLE_BASIN_M9, 0.125,
      PSBAH_20_CASCADIA_INTERFACE_BASIN, 0.125,
      PSBAH_20_CASCADIA_INTERFACE_BASIN_M9, 0.125);

  /* 6.0 Seattle basin and 50% M9 */
  static final class InterfaceSeattle2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Interface 2023 (6.0, Seattle basin + M9)";
    static final Constraints CONSTRAINTS = AtkinsonMacias_2009.CONSTRAINTS;
    static final CoefficientContainer COEFFS = AtkinsonMacias_2009.COEFFS;

    InterfaceSeattle2023(Imt imt) {
      super(imt, INTERFACE_2023_SEATTLE);
    }
  }

  private static final Map<Gmm, Double> INTRASLAB_2023 = Map.of(
      ZHAO_06_INTERFACE_BASIN, 0.25,
      AG_20_CASCADIA_SLAB_BASIN, 0.0825,
      AG_20_CASCADIA_SLAB_ADJUSTED_BASIN, 0.1675,
      KBCG_20_CASCADIA_SLAB_BASIN, 0.25,
      PSBAH_20_CASCADIA_SLAB_BASIN, 0.25);

  /* 6.0 */
  static final class Intraslab2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Intraslab 2023 (6.0, deep basins)";
    static final Constraints CONSTRAINTS = ZhaoEtAl_2006.CONSTRAINTS;
    static final CoefficientContainer COEFFS = ZhaoEtAl_2006.COEFFS;

    Intraslab2023(Imt imt) {
      super(imt, INTRASLAB_2023);
    }
  }

  private static final Map<Gmm, Double> INTRASLAB_2023_SEATTLE = Map.of(
      ZHAO_06_INTERFACE_BASIN, 0.25,
      AG_20_CASCADIA_SLAB_BASIN, 0.0825,
      AG_20_CASCADIA_SLAB_ADJUSTED_BASIN, 0.1675,
      KBCG_20_CASCADIA_SLAB_SEATTLE_BASIN, 0.25,
      PSBAH_20_CASCADIA_SLAB_BASIN, 0.25);

  /* 6.0 Seattle basin */
  static final class IntraslabSeattle2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Intraslab 2023 (6.0, Seattle basin)";
    static final Constraints CONSTRAINTS = ZhaoEtAl_2006.CONSTRAINTS;
    static final CoefficientContainer COEFFS = ZhaoEtAl_2006.COEFFS;

    IntraslabSeattle2023(Imt imt) {
      super(imt, INTRASLAB_2023_SEATTLE);
    }
  }

  private static final Map<Gmm, Double> AK_ACTIVE_CRUST_2007 = Map.of(
      AS_97_AK, 0.25,
      BJF_97_AK, 0.25,
      SADIGH_97, 0.25,
      CB_03_AK_FAULT, 0.25);

  /* 2.0 */
  static final class AkActiveCrust2007 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Alaska Active Crust 2007 (2.0)";
    static final Constraints CONSTRAINTS = AbrahamsonSilva_1997.CONSTRAINTS;
    static final CoefficientContainer COEFFS = SadighEtAl_1997.COEFFS_BC_HI;

    AkActiveCrust2007(Imt imt) {
      super(imt, AK_ACTIVE_CRUST_2007);
    }
  }

  /* 3.0 Same as CONUS 2014 */
  static final class AkActiveCrust2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Alaska Active Crust 2023 (3.0)";
    static final Constraints CONSTRAINTS = CampbellBozorgnia_2014.CONSTRAINTS;
    static final CoefficientContainer COEFFS = CampbellBozorgnia_2014.COEFFS;

    AkActiveCrust2023(Imt imt) {
      super(imt, ACTIVE_CRUST_2014_4P2);
    }
  }

  private static final Map<Gmm, Double> AK_INTERFACE_2007 = Map.of(
      GEOMATRIX_93_INTERFACE, 0.5,
      SADIGH_97_AK_INTERFACE, 0.5);

  /* 2.0 Sadigh only used out to 70km; only Youngs 70 - 1000 km. */
  static final class AkInterface2007 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Alaska Interface 2007 (2.0)";
    static final Constraints CONSTRAINTS = YoungsEtAl_1997.CONSTRAINTS;
    static final CoefficientContainer COEFFS = SadighEtAl_1997.COEFFS_BC_HI;

    AkInterface2007(Imt imt) {
      super(imt, AK_INTERFACE_2007);
    }
  }

  private static final Map<Gmm, Double> AK_INTERFACE_2023 = Map.of(
      AG_20_GLOBAL_INTERFACE, 0.1666,
      AG_20_GLOBAL_INTERFACE_AK_ADJUSTED, 0.1667,
      KBCG_20_GLOBAL_INTERFACE, 0.1666,
      KBCG_20_GLOBAL_INTERFACE_AK_ADJUSTED, 0.1667,
      PSBAH_20_GLOBAL_INTERFACE, 0.1667,
      PSBAH_20_GLOBAL_INTERFACE_AK_ADJUSTED, 0.1667);

  /* 3.0 */
  static final class AkInterface2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Alaska Interface 2023 (3.0)";
    static final Constraints CONSTRAINTS = KuehnEtAl_2020.CONSTRAINTS_INTERFACE;
    static final CoefficientContainer COEFFS = KuehnEtAl_2020.COEFFS;

    AkInterface2023(Imt imt) {
      super(imt, AK_INTERFACE_2023);
    }
  }

  private static final Map<Gmm, Double> AK_INTRASLAB_2007 = Map.of(
      AB_03_GLOBAL_SLAB, 0.5,
      GEOMATRIX_93_SLAB, 0.5);

  /* 2.0 */
  static final class AkIntraslab2007 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Alaska Intraslab 2007 (2.0)";
    static final Constraints CONSTRAINTS = AtkinsonBoore_2003.CONSTRAINTS;
    static final CoefficientContainer COEFFS = Geomatrix_1993.COEFFS;

    AkIntraslab2007(Imt imt) {
      super(imt, AK_INTRASLAB_2007);
    }
  }

  private static final Map<Gmm, Double> AK_INTRASLAB_2023 = Map.of(
      AG_20_ALASKA_SLAB, 0.3333,
      KBCG_20_ALASKA_SLAB, 0.3333,
      PSBAH_20_ALASKA_SLAB, 0.3334);

  /* 3.0 */
  static final class AkIntraslab2023 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "Alaska Intraslab 2023 (3.0)";
    static final Constraints CONSTRAINTS = KuehnEtAl_2020.CONSTRAINTS_SLAB;
    static final CoefficientContainer COEFFS = KuehnEtAl_2020.COEFFS;

    AkIntraslab2023(Imt imt) {
      super(imt, AK_INTRASLAB_2023);
    }
  }

  private static final Map<Gmm, Double> PRVI_ACTIVE_CRUST_2025 = Map.of(
      USGS_PRVI_ACTIVE_CRUST, 0.5,
      USGS_PRVI_ACTIVE_CRUST_ADJUSTED, 0.5);

  /* 2.0 PRVI Active Crust */
  static final class PrviActiveCrust2025 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "PRVI Active Crust 2025 (2.0)";
    static final Constraints CONSTRAINTS = UsgsPrviBackbone2025.ActiveCrust.CONSTRAINTS;
    static final CoefficientContainer COEFFS = UsgsPrviBackbone2025.COEFFS_DATA_ADJUSTMENT;

    PrviActiveCrust2025(Imt imt) {
      super(imt, PRVI_ACTIVE_CRUST_2025);
    }
  }

  private static final Map<Gmm, Double> PRVI_INTERFACE_2025 = Map.of(
      USGS_PRVI_INTERFACE, 0.5,
      USGS_PRVI_INTERFACE_ADJUSTED, 0.5);

  /* 2.0 PRVI Active Crust */
  static final class PrviInterface2025 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "PRVI Interface 2025 (2.0)";
    static final Constraints CONSTRAINTS = UsgsPrviBackbone2025.ActiveCrust.CONSTRAINTS;
    static final CoefficientContainer COEFFS = UsgsPrviBackbone2025.COEFFS_DATA_ADJUSTMENT;

    PrviInterface2025(Imt imt) {
      super(imt, PRVI_INTERFACE_2025);
    }
  }

  private static final Map<Gmm, Double> PRVI_INTRASLAB_2025 = Map.of(
      USGS_PRVI_INTRASLAB, 0.5,
      USGS_PRVI_INTRASLAB_ADJUSTED, 0.5);

  /* 2.0 PRVI Active Crust */
  static final class PrviIntraslab2025 extends CombinedGmm {

    static final String NAME = CombinedGmm.NAME + "PRVI Intraslab 2025 (2.0)";
    static final Constraints CONSTRAINTS = UsgsPrviBackbone2025.ActiveCrust.CONSTRAINTS;
    static final CoefficientContainer COEFFS = UsgsPrviBackbone2025.COEFFS_DATA_ADJUSTMENT;

    PrviIntraslab2025(Imt imt) {
      super(imt, PRVI_INTRASLAB_2025);
    }
  }

}
