package gov.usgs.earthquake.nshmp.model;

import gov.usgs.earthquake.nshmp.fault.surface.RuptureSurface;

/**
 * A mutable {@code Rupture} instance for use with point sources.
 *
 * @author U.S. Geological Survey
 */
class MutableRupture implements Rupture {

  double mag;
  double rake;
  double rate;
  final RuptureSurface surface;

  MutableRupture(RuptureSurface surface) {
    this.surface = surface;
  }

  @Override
  public double mag() {
    return mag;
  }

  @Override
  public double rake() {
    return rake;
  }

  @Override
  public double rate() {
    return rate;
  }

  @Override
  public RuptureSurface surface() {
    return surface;
  }

  @Override
  public String toString() {
    return Rupture.asString(this);
  }

}
